# AccountApi

All URIs are relative to *https://e2e.pt/ws*

Method | HTTP request | Description
------------- | ------------- | -------------
[**accountCreate**](AccountApi.md#accountCreate) | **POST** /account | Create record
[**accountDelete**](AccountApi.md#accountDelete) | **DELETE** /account/{id} | Delete record
[**accountId**](AccountApi.md#accountId) | **GET** /account/id/{id} | Get record
[**accountList**](AccountApi.md#accountList) | **GET** /account | List records
[**accountUpdate**](AccountApi.md#accountUpdate) | **PUT** /account/{id} | Update record
[**addressCreate**](AccountApi.md#addressCreate) | **POST** /account/{accountId}/address | Create record
[**addressDelete**](AccountApi.md#addressDelete) | **DELETE** /account/{accountId}/address/{id} | Delete record
[**addressId**](AccountApi.md#addressId) | **GET** /account/{accountId}/address/id/{id} | Get record
[**addressList**](AccountApi.md#addressList) | **GET** /account/{accountId}/address | List records
[**addressUpdate**](AccountApi.md#addressUpdate) | **PUT** /account/{accountId}/address/{id} | Update record
[**contactCreate**](AccountApi.md#contactCreate) | **POST** /account/{accountId}/contact | Create record
[**contactDelete**](AccountApi.md#contactDelete) | **DELETE** /account/{accountId}/contact/{id} | Delete record
[**contactId**](AccountApi.md#contactId) | **GET** /account/{accountId}/contact/id/{id} | Get record
[**contactList**](AccountApi.md#contactList) | **GET** /account/{accountId}/contact | List records
[**contactTypeList**](AccountApi.md#contactTypeList) | **GET** /account/contact/type | List records
[**contactUpdate**](AccountApi.md#contactUpdate) | **PUT** /account/{accountId}/contact/{id} | Update record
[**currentAccountList**](AccountApi.md#currentAccountList) | **GET** /account/id/{id}/currentAccount | List customer or supplier current account


<a name="accountCreate"></a>
# **accountCreate**
> Account accountCreate(body)

Create record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
Account body = new Account(); // Account | 
try {
    Account result = apiInstance.accountCreate(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#accountCreate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Account**](Account.md)|  |

### Return type

[**Account**](Account.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="accountDelete"></a>
# **accountDelete**
> accountDelete(id)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
String id = "id_example"; // String | 
try {
    apiInstance.accountDelete(id);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#accountDelete");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="accountId"></a>
# **accountId**
> Account accountId(id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
String id = "id_example"; // String | 
try {
    Account result = apiInstance.accountId(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#accountId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

[**Account**](Account.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="accountList"></a>
# **accountList**
> AccountListContainer accountList(offset, limit, name, vatNumber, email, type, updateDate, deleted, ids, salesman, extraFieldsExpression, extraFields)

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
String name = "name_example"; // String | 
String vatNumber = "vatNumber_example"; // String | 
String email = "email_example"; // String | 
String type = "type_example"; // String | 
OffsetDateTime updateDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
Boolean deleted = true; // Boolean | 
List<String> ids = Arrays.asList("ids_example"); // List<String> | 
List<String> salesman = Arrays.asList("salesman_example"); // List<String> | 
String extraFieldsExpression = "extraFieldsExpression_example"; // String | 
List<String> extraFields = Arrays.asList("extraFields_example"); // List<String> | 
try {
    AccountListContainer result = apiInstance.accountList(offset, limit, name, vatNumber, email, type, updateDate, deleted, ids, salesman, extraFieldsExpression, extraFields);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#accountList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]
 **name** | **String**|  | [optional]
 **vatNumber** | **String**|  | [optional]
 **email** | **String**|  | [optional]
 **type** | **String**|  | [optional] [enum: CLIENT, SUPPLIER]
 **updateDate** | **OffsetDateTime**| ISO 8601 | [optional]
 **deleted** | **Boolean**|  | [optional]
 **ids** | [**List&lt;String&gt;**](String.md)|  | [optional]
 **salesman** | [**List&lt;String&gt;**](String.md)|  | [optional]
 **extraFieldsExpression** | **String**|  | [optional]
 **extraFields** | [**List&lt;String&gt;**](String.md)|  | [optional]

### Return type

[**AccountListContainer**](AccountListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="accountUpdate"></a>
# **accountUpdate**
> Account accountUpdate(id, body)

Update record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
String id = "id_example"; // String | 
Account body = new Account(); // Account | 
try {
    Account result = apiInstance.accountUpdate(id, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#accountUpdate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **body** | [**Account**](Account.md)|  |

### Return type

[**Account**](Account.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="addressCreate"></a>
# **addressCreate**
> Address addressCreate(accountId, body)

Create record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
String accountId = "accountId_example"; // String | 
Address body = new Address(); // Address | 
try {
    Address result = apiInstance.addressCreate(accountId, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#addressCreate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**|  |
 **body** | [**Address**](Address.md)|  |

### Return type

[**Address**](Address.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="addressDelete"></a>
# **addressDelete**
> addressDelete(accountId, id)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
String accountId = "accountId_example"; // String | 
String id = "id_example"; // String | 
try {
    apiInstance.addressDelete(accountId, id);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#addressDelete");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**|  |
 **id** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="addressId"></a>
# **addressId**
> Address addressId(accountId, id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
String accountId = "accountId_example"; // String | 
String id = "id_example"; // String | 
try {
    Address result = apiInstance.addressId(accountId, id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#addressId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**|  |
 **id** | **String**|  |

### Return type

[**Address**](Address.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="addressList"></a>
# **addressList**
> AddressListContainer addressList(accountId, offset, limit)

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
String accountId = "accountId_example"; // String | 
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
try {
    AddressListContainer result = apiInstance.addressList(accountId, offset, limit);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#addressList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**|  |
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]

### Return type

[**AddressListContainer**](AddressListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="addressUpdate"></a>
# **addressUpdate**
> Address addressUpdate(accountId, id, body)

Update record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
String accountId = "accountId_example"; // String | 
String id = "id_example"; // String | 
Address body = new Address(); // Address | 
try {
    Address result = apiInstance.addressUpdate(accountId, id, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#addressUpdate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**|  |
 **id** | **String**|  |
 **body** | [**Address**](Address.md)|  |

### Return type

[**Address**](Address.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="contactCreate"></a>
# **contactCreate**
> Contact contactCreate(accountId, body)

Create record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
String accountId = "accountId_example"; // String | 
Contact body = new Contact(); // Contact | 
try {
    Contact result = apiInstance.contactCreate(accountId, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#contactCreate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**|  |
 **body** | [**Contact**](Contact.md)|  |

### Return type

[**Contact**](Contact.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="contactDelete"></a>
# **contactDelete**
> contactDelete(accountId, id)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
String accountId = "accountId_example"; // String | 
String id = "id_example"; // String | 
try {
    apiInstance.contactDelete(accountId, id);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#contactDelete");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**|  |
 **id** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="contactId"></a>
# **contactId**
> Contact contactId(accountId, id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
String accountId = "accountId_example"; // String | 
String id = "id_example"; // String | 
try {
    Contact result = apiInstance.contactId(accountId, id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#contactId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**|  |
 **id** | **String**|  |

### Return type

[**Contact**](Contact.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="contactList"></a>
# **contactList**
> ContactListContainer contactList(accountId, offset, limit, contactType)

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
String accountId = "accountId_example"; // String | 
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
String contactType = "contactType_example"; // String | 
try {
    ContactListContainer result = apiInstance.contactList(accountId, offset, limit, contactType);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#contactList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**|  |
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]
 **contactType** | **String**|  | [optional]

### Return type

[**ContactListContainer**](ContactListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="contactTypeList"></a>
# **contactTypeList**
> ContactTypeListContainer contactTypeList()

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
try {
    ContactTypeListContainer result = apiInstance.contactTypeList();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#contactTypeList");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**ContactTypeListContainer**](ContactTypeListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="contactUpdate"></a>
# **contactUpdate**
> Contact contactUpdate(accountId, id, body)

Update record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
String accountId = "accountId_example"; // String | 
String id = "id_example"; // String | 
Contact body = new Contact(); // Contact | 
try {
    Contact result = apiInstance.contactUpdate(accountId, id, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#contactUpdate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**|  |
 **id** | **String**|  |
 **body** | [**Contact**](Contact.md)|  |

### Return type

[**Contact**](Contact.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="currentAccountList"></a>
# **currentAccountList**
> CurrentAccountListContainer currentAccountList(id, offset, limit, documentName, documentType, documentSerie, startDate, endDate, startDueDate, endDueDate, currentAccountType, account, salesman)

List customer or supplier current account



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AccountApi;


AccountApi apiInstance = new AccountApi();
String id = "id_example"; // String | 
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
String documentName = "documentName_example"; // String | 
String documentType = "documentType_example"; // String | 
String documentSerie = "documentSerie_example"; // String | 
OffsetDateTime startDate = OffsetDateTime.now(); // OffsetDateTime | 
OffsetDateTime endDate = OffsetDateTime.now(); // OffsetDateTime | 
OffsetDateTime startDueDate = OffsetDateTime.now(); // OffsetDateTime | 
OffsetDateTime endDueDate = OffsetDateTime.now(); // OffsetDateTime | 
String currentAccountType = "currentAccountType_example"; // String | 
String account = "account_example"; // String | 
List<String> salesman = Arrays.asList("salesman_example"); // List<String> | 
try {
    CurrentAccountListContainer result = apiInstance.currentAccountList(id, offset, limit, documentName, documentType, documentSerie, startDate, endDate, startDueDate, endDueDate, currentAccountType, account, salesman);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AccountApi#currentAccountList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]
 **documentName** | **String**|  | [optional]
 **documentType** | **String**|  | [optional]
 **documentSerie** | **String**|  | [optional]
 **startDate** | **OffsetDateTime**|  | [optional]
 **endDate** | **OffsetDateTime**|  | [optional]
 **startDueDate** | **OffsetDateTime**|  | [optional]
 **endDueDate** | **OffsetDateTime**|  | [optional]
 **currentAccountType** | **String**|  | [optional] [enum: ALL_DOCUMENTS, PENDING_DOCUMENTS, PAID_DOCUMENTS]
 **account** | **String**|  | [optional]
 **salesman** | [**List&lt;String&gt;**](String.md)|  | [optional]

### Return type

[**CurrentAccountListContainer**](CurrentAccountListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

