# DocumentApi

All URIs are relative to *https://e2e.pt/ws*

Method | HTTP request | Description
------------- | ------------- | -------------
[**documentCreate**](DocumentApi.md#documentCreate) | **POST** /document | Create record
[**documentDiscount**](DocumentApi.md#documentDiscount) | **POST** /document/discount | Get document discount
[**documentEmail**](DocumentApi.md#documentEmail) | **PATCH** /document/email | Send document by mail
[**documentId**](DocumentApi.md#documentId) | **GET** /document/id/{id} | Get record
[**documentList**](DocumentApi.md#documentList) | **GET** /document | List records
[**documenttypeList**](DocumentApi.md#documenttypeList) | **GET** /document/type | List document types and series


<a name="documentCreate"></a>
# **documentCreate**
> Document documentCreate(body)

Create record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.DocumentApi;


DocumentApi apiInstance = new DocumentApi();
Document body = new Document(); // Document | 
try {
    Document result = apiInstance.documentCreate(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling DocumentApi#documentCreate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Document**](Document.md)|  |

### Return type

[**Document**](Document.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="documentDiscount"></a>
# **documentDiscount**
> Document documentDiscount(body)

Get document discount



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.DocumentApi;


DocumentApi apiInstance = new DocumentApi();
Document body = new Document(); // Document | 
try {
    Document result = apiInstance.documentDiscount(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling DocumentApi#documentDiscount");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Document**](Document.md)|  |

### Return type

[**Document**](Document.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="documentEmail"></a>
# **documentEmail**
> documentEmail(id, toEmail, fromEmail, fromName, subject)

Send document by mail



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.DocumentApi;


DocumentApi apiInstance = new DocumentApi();
String id = "id_example"; // String | 
String toEmail = "toEmail_example"; // String | 
String fromEmail = "fromEmail_example"; // String | 
String fromName = "fromName_example"; // String | 
String subject = "subject_example"; // String | 
try {
    apiInstance.documentEmail(id, toEmail, fromEmail, fromName, subject);
} catch (ApiException e) {
    System.err.println("Exception when calling DocumentApi#documentEmail");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **toEmail** | **String**|  | [optional]
 **fromEmail** | **String**|  | [optional]
 **fromName** | **String**|  | [optional]
 **subject** | **String**|  | [optional]

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="documentId"></a>
# **documentId**
> Document documentId(id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.DocumentApi;


DocumentApi apiInstance = new DocumentApi();
String id = "id_example"; // String | 
try {
    Document result = apiInstance.documentId(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling DocumentApi#documentId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

[**Document**](Document.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="documentList"></a>
# **documentList**
> DocumentListContainer documentList(offset, limit, number, startDate, endDate, type1, type2, updateDate, account, product, productCategory, deleted, name, type, serie, salesman, extraFieldsExpression, extraFields)

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.DocumentApi;


DocumentApi apiInstance = new DocumentApi();
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
Integer number = 56; // Integer | 
OffsetDateTime startDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
OffsetDateTime endDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
String type1 = "type1_example"; // String | 
String type2 = "type2_example"; // String | 
OffsetDateTime updateDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
String account = "account_example"; // String | 
String product = "product_example"; // String | 
String productCategory = "productCategory_example"; // String | 
Boolean deleted = true; // Boolean | 
String name = "name_example"; // String | 
List<String> type = Arrays.asList("type_example"); // List<String> | 
List<String> serie = Arrays.asList("serie_example"); // List<String> | 
List<String> salesman = Arrays.asList("salesman_example"); // List<String> | 
String extraFieldsExpression = "extraFieldsExpression_example"; // String | 
List<String> extraFields = Arrays.asList("extraFields_example"); // List<String> | 
try {
    DocumentListContainer result = apiInstance.documentList(offset, limit, number, startDate, endDate, type1, type2, updateDate, account, product, productCategory, deleted, name, type, serie, salesman, extraFieldsExpression, extraFields);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling DocumentApi#documentList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]
 **number** | **Integer**|  | [optional]
 **startDate** | **OffsetDateTime**| ISO 8601 | [optional]
 **endDate** | **OffsetDateTime**| ISO 8601 | [optional]
 **type1** | **String**|  | [optional] [enum: SALES, PURCHASES, INTERNAL]
 **type2** | **String**|  | [optional] [enum: FINANCIAL, STOCK, ORDER, QUOTE, INTERNAL]
 **updateDate** | **OffsetDateTime**| ISO 8601 | [optional]
 **account** | **String**|  | [optional]
 **product** | **String**|  | [optional]
 **productCategory** | **String**|  | [optional]
 **deleted** | **Boolean**|  | [optional]
 **name** | **String**|  | [optional]
 **type** | [**List&lt;String&gt;**](String.md)|  | [optional]
 **serie** | [**List&lt;String&gt;**](String.md)|  | [optional]
 **salesman** | [**List&lt;String&gt;**](String.md)|  | [optional]
 **extraFieldsExpression** | **String**|  | [optional]
 **extraFields** | [**List&lt;String&gt;**](String.md)|  | [optional]

### Return type

[**DocumentListContainer**](DocumentListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="documenttypeList"></a>
# **documenttypeList**
> DocumentTypeListContainer documenttypeList(type, serie, type1, type2, userType, userId)

List document types and series



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.DocumentApi;


DocumentApi apiInstance = new DocumentApi();
String type = "type_example"; // String | 
String serie = "serie_example"; // String | 
String type1 = "type1_example"; // String | 
String type2 = "type2_example"; // String | 
String userType = "userType_example"; // String | 
String userId = "userId_example"; // String | 
try {
    DocumentTypeListContainer result = apiInstance.documenttypeList(type, serie, type1, type2, userType, userId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling DocumentApi#documenttypeList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **type** | **String**|  | [optional]
 **serie** | **String**|  | [optional]
 **type1** | **String**|  | [optional] [enum: SALES, PURCHASES, INTERNAL]
 **type2** | **String**|  | [optional] [enum: FINANCIAL, STOCK, ORDER, QUOTE, INTERNAL]
 **userType** | **String**|  | [optional] [enum: SALESMAN, CLIENT]
 **userId** | **String**|  | [optional]

### Return type

[**DocumentTypeListContainer**](DocumentTypeListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

