# HrApi

All URIs are relative to *https://e2e.pt/ws*

Method | HTTP request | Description
------------- | ------------- | -------------
[**employeeAllFiles**](HrApi.md#employeeAllFiles) | **GET** /hr/employee/files | Get files
[**employeeCreate**](HrApi.md#employeeCreate) | **POST** /hr/employee | Create record
[**employeeDelete**](HrApi.md#employeeDelete) | **DELETE** /hr/employee/{id} | Delete record
[**employeeFileDownloadBase64**](HrApi.md#employeeFileDownloadBase64) | **GET** /hr/employee/id/{id}/file/{fileId}/base64 | Get record file
[**employeeFileDownloadBin**](HrApi.md#employeeFileDownloadBin) | **GET** /hr/employee/id/{id}/file/{fileId}/bin | Get record file
[**employeeFiles**](HrApi.md#employeeFiles) | **GET** /hr/employee/id/{id}/file | Get record files
[**employeeId**](HrApi.md#employeeId) | **GET** /hr/employee/id/{id} | Get record
[**employeeList**](HrApi.md#employeeList) | **GET** /hr/employee | List records
[**employeeUpdate**](HrApi.md#employeeUpdate) | **PUT** /hr/employee/{id} | Update record
[**monthlyPayrollSupplementCreate**](HrApi.md#monthlyPayrollSupplementCreate) | **POST** /hr/monthly_payroll_supplement | Create record
[**monthlyPayrollSupplementCreatePack**](HrApi.md#monthlyPayrollSupplementCreatePack) | **POST** /hr/monthly_payroll_supplement/pack/{packid} | Create record
[**monthlyPayrollSupplementDelete**](HrApi.md#monthlyPayrollSupplementDelete) | **DELETE** /hr/monthly_payroll_supplement/id/{id} | Delete record
[**monthlyPayrollSupplementDeleteExternalId**](HrApi.md#monthlyPayrollSupplementDeleteExternalId) | **DELETE** /hr/monthly_payroll_supplement/external/{source}/{id} | Delete record
[**monthlyPayrollSupplementDeleteExternalIdPack**](HrApi.md#monthlyPayrollSupplementDeleteExternalIdPack) | **DELETE** /hr/monthly_payroll_supplement/external/{source}/{id}/pack/{packid} | Delete record
[**monthlyPayrollSupplementDeletePack**](HrApi.md#monthlyPayrollSupplementDeletePack) | **DELETE** /hr/monthly_payroll_supplement/id/{id}/pack/{packid} | Delete record
[**monthlyPayrollSupplementExternalId**](HrApi.md#monthlyPayrollSupplementExternalId) | **GET** /hr/monthly_payroll_supplement/external/{source}/{id} | Get record
[**monthlyPayrollSupplementId**](HrApi.md#monthlyPayrollSupplementId) | **GET** /hr/monthly_payroll_supplement/id/{id} | Get record
[**monthlyPayrollSupplementList**](HrApi.md#monthlyPayrollSupplementList) | **GET** /hr/monthly_payroll_supplement | List records
[**monthlyPayrollSupplementUpdate**](HrApi.md#monthlyPayrollSupplementUpdate) | **PUT** /hr/monthly_payroll_supplement/{id} | Update record
[**monthlyPayrollSupplementUpdatePack**](HrApi.md#monthlyPayrollSupplementUpdatePack) | **PUT** /hr/monthly_payroll_supplement/{id}/pack/{packid} | Update record
[**payrollSupplementCreate**](HrApi.md#payrollSupplementCreate) | **POST** /hr/payroll_supplement | Create record
[**payrollSupplementCreatePack**](HrApi.md#payrollSupplementCreatePack) | **POST** /hr/payroll_supplement/pack/{packid} | Create record
[**payrollSupplementDelete**](HrApi.md#payrollSupplementDelete) | **DELETE** /hr/payroll_supplement/id/{id} | Delete record
[**payrollSupplementDeleteExternalId**](HrApi.md#payrollSupplementDeleteExternalId) | **DELETE** /hr/payroll_supplement/external/{source}/{id} | Delete record
[**payrollSupplementDeleteExternalIdPack**](HrApi.md#payrollSupplementDeleteExternalIdPack) | **DELETE** /hr/payroll_supplement/external/{source}/{id}/pack/{packid} | Delete record
[**payrollSupplementDeletePack**](HrApi.md#payrollSupplementDeletePack) | **DELETE** /hr/payroll_supplement/id/{id}/pack/{packid} | Delete record
[**payrollSupplementExternalId**](HrApi.md#payrollSupplementExternalId) | **GET** /hr/payroll_supplement/external/{source}/{id} | Get record
[**payrollSupplementId**](HrApi.md#payrollSupplementId) | **GET** /hr/payroll_supplement/id/{id} | Get record
[**payrollSupplementList**](HrApi.md#payrollSupplementList) | **GET** /hr/payroll_supplement | List records
[**payrollSupplementTypeList**](HrApi.md#payrollSupplementTypeList) | **GET** /hr/payroll_supplement/payroll_supplement_type | List records
[**payrollSupplementUpdate**](HrApi.md#payrollSupplementUpdate) | **PUT** /hr/payroll_supplement/{id} | Update record
[**payrollSupplementUpdatePack**](HrApi.md#payrollSupplementUpdatePack) | **PUT** /hr/payroll_supplement/{id}/pack/{packid} | Update record
[**timeAttendanceId**](HrApi.md#timeAttendanceId) | **GET** /hr/time_attendance/id/{id} | Get record
[**timeAttendanceList**](HrApi.md#timeAttendanceList) | **GET** /hr/time_attendance | List records
[**timeExtraCreate**](HrApi.md#timeExtraCreate) | **POST** /hr/time_extra | Create record
[**timeExtraCreatePack**](HrApi.md#timeExtraCreatePack) | **POST** /hr/time_extra/pack/{packid} | Create record
[**timeExtraDelete**](HrApi.md#timeExtraDelete) | **DELETE** /hr/time_extra/id/{id} | Delete record
[**timeExtraDeleteExternalId**](HrApi.md#timeExtraDeleteExternalId) | **DELETE** /hr/time_extra/external/{source}/{id} | Delete record
[**timeExtraDeleteExternalIdPack**](HrApi.md#timeExtraDeleteExternalIdPack) | **DELETE** /hr/time_extra/external/{source}/{id}/pack/{packid} | Delete record
[**timeExtraDeletePack**](HrApi.md#timeExtraDeletePack) | **DELETE** /hr/time_extra/id/{id}/pack/{packid} | Delete record
[**timeExtraExternalId**](HrApi.md#timeExtraExternalId) | **GET** /hr/time_extra/external/{source}/{id} | Get record
[**timeExtraId**](HrApi.md#timeExtraId) | **GET** /hr/time_extra/id/{id} | Get record
[**timeExtraList**](HrApi.md#timeExtraList) | **GET** /hr/time_extra | List records
[**timeExtraTypeList**](HrApi.md#timeExtraTypeList) | **GET** /hr/time_extra/time_extra_type | List records
[**timeExtraUpdate**](HrApi.md#timeExtraUpdate) | **PUT** /hr/time_extra/{id} | Update record
[**timeExtraUpdatePack**](HrApi.md#timeExtraUpdatePack) | **PUT** /hr/time_extra/{id}/pack/{packid} | Update record
[**timeOffLeaveCreate**](HrApi.md#timeOffLeaveCreate) | **POST** /hr/time_off_leave | Create record
[**timeOffLeaveDelete**](HrApi.md#timeOffLeaveDelete) | **DELETE** /hr/time_off_leave/id/{id} | Delete record
[**timeOffLeaveDeleteExternalId**](HrApi.md#timeOffLeaveDeleteExternalId) | **DELETE** /hr/time_off_leave/external/{source}/{id} | Delete record
[**timeOffLeaveExternalId**](HrApi.md#timeOffLeaveExternalId) | **GET** /hr/time_off_leave/external/{source}/{id} | Get record
[**timeOffLeaveId**](HrApi.md#timeOffLeaveId) | **GET** /hr/time_off_leave/id/{id} | Get record
[**timeOffLeaveList**](HrApi.md#timeOffLeaveList) | **GET** /hr/time_off_leave | List records
[**timeOffLeaveUpdate**](HrApi.md#timeOffLeaveUpdate) | **PUT** /hr/time_off_leave/{id} | Update record
[**timeOffLeavetypeList**](HrApi.md#timeOffLeavetypeList) | **GET** /hr/time_off_leave/time_off_leave_type | List records


<a name="employeeAllFiles"></a>
# **employeeAllFiles**
> FileListContainer employeeAllFiles(offset, limit, hrFileType, employeeId, employeeDeleted, start, end)

Get files



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
String hrFileType = "hrFileType_example"; // String | 
String employeeId = "employeeId_example"; // String | 
Boolean employeeDeleted = true; // Boolean | 
OffsetDateTime start = OffsetDateTime.now(); // OffsetDateTime | 
OffsetDateTime end = OffsetDateTime.now(); // OffsetDateTime | 
try {
    FileListContainer result = apiInstance.employeeAllFiles(offset, limit, hrFileType, employeeId, employeeDeleted, start, end);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#employeeAllFiles");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]
 **hrFileType** | **String**|  | [optional]
 **employeeId** | **String**|  | [optional]
 **employeeDeleted** | **Boolean**|  | [optional]
 **start** | **OffsetDateTime**|  | [optional]
 **end** | **OffsetDateTime**|  | [optional]

### Return type

[**FileListContainer**](FileListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="employeeCreate"></a>
# **employeeCreate**
> Employee employeeCreate(body)

Create record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
Employee body = new Employee(); // Employee | 
try {
    Employee result = apiInstance.employeeCreate(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#employeeCreate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Employee**](Employee.md)|  |

### Return type

[**Employee**](Employee.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="employeeDelete"></a>
# **employeeDelete**
> employeeDelete(id)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
try {
    apiInstance.employeeDelete(id);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#employeeDelete");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="employeeFileDownloadBase64"></a>
# **employeeFileDownloadBase64**
> String employeeFileDownloadBase64(id, fileId)

Get record file



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
String fileId = "fileId_example"; // String | 
try {
    String result = apiInstance.employeeFileDownloadBase64(id, fileId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#employeeFileDownloadBase64");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **fileId** | **String**|  |

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: text/plain

<a name="employeeFileDownloadBin"></a>
# **employeeFileDownloadBin**
> File employeeFileDownloadBin(id, fileId)

Get record file



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
String fileId = "fileId_example"; // String | 
try {
    File result = apiInstance.employeeFileDownloadBin(id, fileId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#employeeFileDownloadBin");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **fileId** | **String**|  |

### Return type

[**File**](File.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/octet-stream

<a name="employeeFiles"></a>
# **employeeFiles**
> FileListContainer employeeFiles(id)

Get record files



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
try {
    FileListContainer result = apiInstance.employeeFiles(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#employeeFiles");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

[**FileListContainer**](FileListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="employeeId"></a>
# **employeeId**
> Employee employeeId(id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
try {
    Employee result = apiInstance.employeeId(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#employeeId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

[**Employee**](Employee.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="employeeList"></a>
# **employeeList**
> EmployeeListContainer employeeList(offset, limit, name, nationalNumber, taxNumber, email, deleted, ids)

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
String name = "name_example"; // String | 
String nationalNumber = "nationalNumber_example"; // String | 
String taxNumber = "taxNumber_example"; // String | 
String email = "email_example"; // String | 
Boolean deleted = true; // Boolean | 
List<String> ids = Arrays.asList("ids_example"); // List<String> | 
try {
    EmployeeListContainer result = apiInstance.employeeList(offset, limit, name, nationalNumber, taxNumber, email, deleted, ids);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#employeeList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]
 **name** | **String**|  | [optional]
 **nationalNumber** | **String**|  | [optional]
 **taxNumber** | **String**|  | [optional]
 **email** | **String**|  | [optional]
 **deleted** | **Boolean**|  | [optional]
 **ids** | [**List&lt;String&gt;**](String.md)|  | [optional]

### Return type

[**EmployeeListContainer**](EmployeeListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="employeeUpdate"></a>
# **employeeUpdate**
> Employee employeeUpdate(id, body)

Update record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
Employee body = new Employee(); // Employee | 
try {
    Employee result = apiInstance.employeeUpdate(id, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#employeeUpdate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **body** | [**Employee**](Employee.md)|  |

### Return type

[**Employee**](Employee.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="monthlyPayrollSupplementCreate"></a>
# **monthlyPayrollSupplementCreate**
> PayrollSupplement monthlyPayrollSupplementCreate(body)

Create record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
PayrollSupplement body = new PayrollSupplement(); // PayrollSupplement | 
try {
    PayrollSupplement result = apiInstance.monthlyPayrollSupplementCreate(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#monthlyPayrollSupplementCreate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  |

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="monthlyPayrollSupplementCreatePack"></a>
# **monthlyPayrollSupplementCreatePack**
> PayrollSupplement monthlyPayrollSupplementCreatePack(packid, body)

Create record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String packid = "packid_example"; // String | 
PayrollSupplement body = new PayrollSupplement(); // PayrollSupplement | 
try {
    PayrollSupplement result = apiInstance.monthlyPayrollSupplementCreatePack(packid, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#monthlyPayrollSupplementCreatePack");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **packid** | **String**|  |
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  |

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="monthlyPayrollSupplementDelete"></a>
# **monthlyPayrollSupplementDelete**
> monthlyPayrollSupplementDelete(id)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
try {
    apiInstance.monthlyPayrollSupplementDelete(id);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#monthlyPayrollSupplementDelete");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="monthlyPayrollSupplementDeleteExternalId"></a>
# **monthlyPayrollSupplementDeleteExternalId**
> monthlyPayrollSupplementDeleteExternalId(source, id)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String source = "source_example"; // String | 
String id = "id_example"; // String | 
try {
    apiInstance.monthlyPayrollSupplementDeleteExternalId(source, id);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#monthlyPayrollSupplementDeleteExternalId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **String**|  |
 **id** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="monthlyPayrollSupplementDeleteExternalIdPack"></a>
# **monthlyPayrollSupplementDeleteExternalIdPack**
> monthlyPayrollSupplementDeleteExternalIdPack(source, id, packid)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String source = "source_example"; // String | 
String id = "id_example"; // String | 
String packid = "packid_example"; // String | 
try {
    apiInstance.monthlyPayrollSupplementDeleteExternalIdPack(source, id, packid);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#monthlyPayrollSupplementDeleteExternalIdPack");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **String**|  |
 **id** | **String**|  |
 **packid** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="monthlyPayrollSupplementDeletePack"></a>
# **monthlyPayrollSupplementDeletePack**
> monthlyPayrollSupplementDeletePack(id, packid)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
String packid = "packid_example"; // String | 
try {
    apiInstance.monthlyPayrollSupplementDeletePack(id, packid);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#monthlyPayrollSupplementDeletePack");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **packid** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="monthlyPayrollSupplementExternalId"></a>
# **monthlyPayrollSupplementExternalId**
> PayrollSupplement monthlyPayrollSupplementExternalId(source, id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String source = "source_example"; // String | 
String id = "id_example"; // String | 
try {
    PayrollSupplement result = apiInstance.monthlyPayrollSupplementExternalId(source, id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#monthlyPayrollSupplementExternalId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **String**|  |
 **id** | **String**|  |

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="monthlyPayrollSupplementId"></a>
# **monthlyPayrollSupplementId**
> PayrollSupplement monthlyPayrollSupplementId(id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
try {
    PayrollSupplement result = apiInstance.monthlyPayrollSupplementId(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#monthlyPayrollSupplementId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="monthlyPayrollSupplementList"></a>
# **monthlyPayrollSupplementList**
> PayrollSupplementListContainer monthlyPayrollSupplementList(offset, limit, employee, type, startDate, endDate)

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
String employee = "employee_example"; // String | 
String type = "type_example"; // String | 
OffsetDateTime startDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
OffsetDateTime endDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
try {
    PayrollSupplementListContainer result = apiInstance.monthlyPayrollSupplementList(offset, limit, employee, type, startDate, endDate);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#monthlyPayrollSupplementList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]
 **employee** | **String**|  | [optional]
 **type** | **String**|  | [optional]
 **startDate** | **OffsetDateTime**| ISO 8601 | [optional]
 **endDate** | **OffsetDateTime**| ISO 8601 | [optional]

### Return type

[**PayrollSupplementListContainer**](PayrollSupplementListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="monthlyPayrollSupplementUpdate"></a>
# **monthlyPayrollSupplementUpdate**
> PayrollSupplement monthlyPayrollSupplementUpdate(id, body)

Update record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
PayrollSupplement body = new PayrollSupplement(); // PayrollSupplement | 
try {
    PayrollSupplement result = apiInstance.monthlyPayrollSupplementUpdate(id, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#monthlyPayrollSupplementUpdate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  |

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="monthlyPayrollSupplementUpdatePack"></a>
# **monthlyPayrollSupplementUpdatePack**
> PayrollSupplement monthlyPayrollSupplementUpdatePack(id, packid, body)

Update record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
String packid = "packid_example"; // String | 
PayrollSupplement body = new PayrollSupplement(); // PayrollSupplement | 
try {
    PayrollSupplement result = apiInstance.monthlyPayrollSupplementUpdatePack(id, packid, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#monthlyPayrollSupplementUpdatePack");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **packid** | **String**|  |
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  |

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="payrollSupplementCreate"></a>
# **payrollSupplementCreate**
> PayrollSupplement payrollSupplementCreate(body)

Create record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
PayrollSupplement body = new PayrollSupplement(); // PayrollSupplement | 
try {
    PayrollSupplement result = apiInstance.payrollSupplementCreate(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#payrollSupplementCreate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  |

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="payrollSupplementCreatePack"></a>
# **payrollSupplementCreatePack**
> PayrollSupplement payrollSupplementCreatePack(packid, body)

Create record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String packid = "packid_example"; // String | 
PayrollSupplement body = new PayrollSupplement(); // PayrollSupplement | 
try {
    PayrollSupplement result = apiInstance.payrollSupplementCreatePack(packid, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#payrollSupplementCreatePack");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **packid** | **String**|  |
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  |

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="payrollSupplementDelete"></a>
# **payrollSupplementDelete**
> payrollSupplementDelete(id)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
try {
    apiInstance.payrollSupplementDelete(id);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#payrollSupplementDelete");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="payrollSupplementDeleteExternalId"></a>
# **payrollSupplementDeleteExternalId**
> payrollSupplementDeleteExternalId(source, id)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String source = "source_example"; // String | 
String id = "id_example"; // String | 
try {
    apiInstance.payrollSupplementDeleteExternalId(source, id);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#payrollSupplementDeleteExternalId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **String**|  |
 **id** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="payrollSupplementDeleteExternalIdPack"></a>
# **payrollSupplementDeleteExternalIdPack**
> payrollSupplementDeleteExternalIdPack(source, id, packid)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String source = "source_example"; // String | 
String id = "id_example"; // String | 
String packid = "packid_example"; // String | 
try {
    apiInstance.payrollSupplementDeleteExternalIdPack(source, id, packid);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#payrollSupplementDeleteExternalIdPack");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **String**|  |
 **id** | **String**|  |
 **packid** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="payrollSupplementDeletePack"></a>
# **payrollSupplementDeletePack**
> payrollSupplementDeletePack(id, packid)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
String packid = "packid_example"; // String | 
try {
    apiInstance.payrollSupplementDeletePack(id, packid);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#payrollSupplementDeletePack");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **packid** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="payrollSupplementExternalId"></a>
# **payrollSupplementExternalId**
> PayrollSupplement payrollSupplementExternalId(source, id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String source = "source_example"; // String | 
String id = "id_example"; // String | 
try {
    PayrollSupplement result = apiInstance.payrollSupplementExternalId(source, id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#payrollSupplementExternalId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **String**|  |
 **id** | **String**|  |

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="payrollSupplementId"></a>
# **payrollSupplementId**
> PayrollSupplement payrollSupplementId(id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
try {
    PayrollSupplement result = apiInstance.payrollSupplementId(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#payrollSupplementId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="payrollSupplementList"></a>
# **payrollSupplementList**
> PayrollSupplementListContainer payrollSupplementList(offset, limit, employee, type, startDate, endDate)

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
String employee = "employee_example"; // String | 
String type = "type_example"; // String | 
OffsetDateTime startDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
OffsetDateTime endDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
try {
    PayrollSupplementListContainer result = apiInstance.payrollSupplementList(offset, limit, employee, type, startDate, endDate);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#payrollSupplementList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]
 **employee** | **String**|  | [optional]
 **type** | **String**|  | [optional]
 **startDate** | **OffsetDateTime**| ISO 8601 | [optional]
 **endDate** | **OffsetDateTime**| ISO 8601 | [optional]

### Return type

[**PayrollSupplementListContainer**](PayrollSupplementListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="payrollSupplementTypeList"></a>
# **payrollSupplementTypeList**
> PayrollSupplementTypeListContainer payrollSupplementTypeList()

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
try {
    PayrollSupplementTypeListContainer result = apiInstance.payrollSupplementTypeList();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#payrollSupplementTypeList");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**PayrollSupplementTypeListContainer**](PayrollSupplementTypeListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="payrollSupplementUpdate"></a>
# **payrollSupplementUpdate**
> PayrollSupplement payrollSupplementUpdate(id, body)

Update record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
PayrollSupplement body = new PayrollSupplement(); // PayrollSupplement | 
try {
    PayrollSupplement result = apiInstance.payrollSupplementUpdate(id, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#payrollSupplementUpdate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  |

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="payrollSupplementUpdatePack"></a>
# **payrollSupplementUpdatePack**
> PayrollSupplement payrollSupplementUpdatePack(id, packid, body)

Update record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
String packid = "packid_example"; // String | 
PayrollSupplement body = new PayrollSupplement(); // PayrollSupplement | 
try {
    PayrollSupplement result = apiInstance.payrollSupplementUpdatePack(id, packid, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#payrollSupplementUpdatePack");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **packid** | **String**|  |
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  |

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="timeAttendanceId"></a>
# **timeAttendanceId**
> TimeAttendance timeAttendanceId(id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
try {
    TimeAttendance result = apiInstance.timeAttendanceId(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeAttendanceId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

[**TimeAttendance**](TimeAttendance.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="timeAttendanceList"></a>
# **timeAttendanceList**
> TimeAttendanceListContainer timeAttendanceList(offset, limit, employee, type, startDate, endDate)

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
String employee = "employee_example"; // String | 
String type = "type_example"; // String | 
OffsetDateTime startDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
OffsetDateTime endDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
try {
    TimeAttendanceListContainer result = apiInstance.timeAttendanceList(offset, limit, employee, type, startDate, endDate);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeAttendanceList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]
 **employee** | **String**|  | [optional]
 **type** | **String**|  | [optional] [enum: IN, OUT]
 **startDate** | **OffsetDateTime**| ISO 8601 | [optional]
 **endDate** | **OffsetDateTime**| ISO 8601 | [optional]

### Return type

[**TimeAttendanceListContainer**](TimeAttendanceListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="timeExtraCreate"></a>
# **timeExtraCreate**
> TimeExtra timeExtraCreate(body)

Create record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
TimeExtra body = new TimeExtra(); // TimeExtra | 
try {
    TimeExtra result = apiInstance.timeExtraCreate(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeExtraCreate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**TimeExtra**](TimeExtra.md)|  |

### Return type

[**TimeExtra**](TimeExtra.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="timeExtraCreatePack"></a>
# **timeExtraCreatePack**
> TimeExtra timeExtraCreatePack(packid, body)

Create record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String packid = "packid_example"; // String | 
TimeExtra body = new TimeExtra(); // TimeExtra | 
try {
    TimeExtra result = apiInstance.timeExtraCreatePack(packid, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeExtraCreatePack");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **packid** | **String**|  |
 **body** | [**TimeExtra**](TimeExtra.md)|  |

### Return type

[**TimeExtra**](TimeExtra.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="timeExtraDelete"></a>
# **timeExtraDelete**
> timeExtraDelete(id)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
try {
    apiInstance.timeExtraDelete(id);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeExtraDelete");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="timeExtraDeleteExternalId"></a>
# **timeExtraDeleteExternalId**
> timeExtraDeleteExternalId(source, id)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String source = "source_example"; // String | 
String id = "id_example"; // String | 
try {
    apiInstance.timeExtraDeleteExternalId(source, id);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeExtraDeleteExternalId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **String**|  |
 **id** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="timeExtraDeleteExternalIdPack"></a>
# **timeExtraDeleteExternalIdPack**
> timeExtraDeleteExternalIdPack(source, id, packid)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String source = "source_example"; // String | 
String id = "id_example"; // String | 
String packid = "packid_example"; // String | 
try {
    apiInstance.timeExtraDeleteExternalIdPack(source, id, packid);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeExtraDeleteExternalIdPack");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **String**|  |
 **id** | **String**|  |
 **packid** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="timeExtraDeletePack"></a>
# **timeExtraDeletePack**
> timeExtraDeletePack(id, packid)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
String packid = "packid_example"; // String | 
try {
    apiInstance.timeExtraDeletePack(id, packid);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeExtraDeletePack");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **packid** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="timeExtraExternalId"></a>
# **timeExtraExternalId**
> TimeExtra timeExtraExternalId(source, id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String source = "source_example"; // String | 
String id = "id_example"; // String | 
try {
    TimeExtra result = apiInstance.timeExtraExternalId(source, id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeExtraExternalId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **String**|  |
 **id** | **String**|  |

### Return type

[**TimeExtra**](TimeExtra.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="timeExtraId"></a>
# **timeExtraId**
> TimeExtra timeExtraId(id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
try {
    TimeExtra result = apiInstance.timeExtraId(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeExtraId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

[**TimeExtra**](TimeExtra.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="timeExtraList"></a>
# **timeExtraList**
> TimeExtraListContainer timeExtraList(offset, limit, employee, type, startDate, endDate)

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
String employee = "employee_example"; // String | 
String type = "type_example"; // String | 
OffsetDateTime startDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
OffsetDateTime endDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
try {
    TimeExtraListContainer result = apiInstance.timeExtraList(offset, limit, employee, type, startDate, endDate);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeExtraList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]
 **employee** | **String**|  | [optional]
 **type** | **String**|  | [optional]
 **startDate** | **OffsetDateTime**| ISO 8601 | [optional]
 **endDate** | **OffsetDateTime**| ISO 8601 | [optional]

### Return type

[**TimeExtraListContainer**](TimeExtraListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="timeExtraTypeList"></a>
# **timeExtraTypeList**
> TimeExtraTypeListContainer timeExtraTypeList()

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
try {
    TimeExtraTypeListContainer result = apiInstance.timeExtraTypeList();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeExtraTypeList");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**TimeExtraTypeListContainer**](TimeExtraTypeListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="timeExtraUpdate"></a>
# **timeExtraUpdate**
> TimeExtra timeExtraUpdate(id, body)

Update record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
TimeExtra body = new TimeExtra(); // TimeExtra | 
try {
    TimeExtra result = apiInstance.timeExtraUpdate(id, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeExtraUpdate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **body** | [**TimeExtra**](TimeExtra.md)|  |

### Return type

[**TimeExtra**](TimeExtra.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="timeExtraUpdatePack"></a>
# **timeExtraUpdatePack**
> TimeExtra timeExtraUpdatePack(id, packid, body)

Update record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
String packid = "packid_example"; // String | 
TimeExtra body = new TimeExtra(); // TimeExtra | 
try {
    TimeExtra result = apiInstance.timeExtraUpdatePack(id, packid, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeExtraUpdatePack");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **packid** | **String**|  |
 **body** | [**TimeExtra**](TimeExtra.md)|  |

### Return type

[**TimeExtra**](TimeExtra.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="timeOffLeaveCreate"></a>
# **timeOffLeaveCreate**
> TimeOffLeave timeOffLeaveCreate(body)

Create record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
TimeOffLeave body = new TimeOffLeave(); // TimeOffLeave | 
try {
    TimeOffLeave result = apiInstance.timeOffLeaveCreate(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeOffLeaveCreate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**TimeOffLeave**](TimeOffLeave.md)|  |

### Return type

[**TimeOffLeave**](TimeOffLeave.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="timeOffLeaveDelete"></a>
# **timeOffLeaveDelete**
> timeOffLeaveDelete(id)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
try {
    apiInstance.timeOffLeaveDelete(id);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeOffLeaveDelete");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="timeOffLeaveDeleteExternalId"></a>
# **timeOffLeaveDeleteExternalId**
> timeOffLeaveDeleteExternalId(source, id)

Delete record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String source = "source_example"; // String | 
String id = "id_example"; // String | 
try {
    apiInstance.timeOffLeaveDeleteExternalId(source, id);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeOffLeaveDeleteExternalId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **String**|  |
 **id** | **String**|  |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="timeOffLeaveExternalId"></a>
# **timeOffLeaveExternalId**
> TimeOffLeave timeOffLeaveExternalId(source, id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String source = "source_example"; // String | 
String id = "id_example"; // String | 
try {
    TimeOffLeave result = apiInstance.timeOffLeaveExternalId(source, id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeOffLeaveExternalId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **String**|  |
 **id** | **String**|  |

### Return type

[**TimeOffLeave**](TimeOffLeave.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="timeOffLeaveId"></a>
# **timeOffLeaveId**
> TimeOffLeave timeOffLeaveId(id)

Get record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
try {
    TimeOffLeave result = apiInstance.timeOffLeaveId(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeOffLeaveId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |

### Return type

[**TimeOffLeave**](TimeOffLeave.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="timeOffLeaveList"></a>
# **timeOffLeaveList**
> TimeOffLeaveListContainer timeOffLeaveList(offset, limit, employee, type, startDate, endDate, approved)

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
Integer offset = 0; // Integer | 
Integer limit = 100; // Integer | 
String employee = "employee_example"; // String | 
String type = "type_example"; // String | 
OffsetDateTime startDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
OffsetDateTime endDate = OffsetDateTime.now(); // OffsetDateTime | ISO 8601
Boolean approved = true; // Boolean | 
try {
    TimeOffLeaveListContainer result = apiInstance.timeOffLeaveList(offset, limit, employee, type, startDate, endDate, approved);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeOffLeaveList");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **Integer**|  | [optional] [default to 0]
 **limit** | **Integer**|  | [optional] [default to 100]
 **employee** | **String**|  | [optional]
 **type** | **String**|  | [optional]
 **startDate** | **OffsetDateTime**| ISO 8601 | [optional]
 **endDate** | **OffsetDateTime**| ISO 8601 | [optional]
 **approved** | **Boolean**|  | [optional]

### Return type

[**TimeOffLeaveListContainer**](TimeOffLeaveListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="timeOffLeaveUpdate"></a>
# **timeOffLeaveUpdate**
> TimeOffLeave timeOffLeaveUpdate(id, body)

Update record



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
String id = "id_example"; // String | 
TimeOffLeave body = new TimeOffLeave(); // TimeOffLeave | 
try {
    TimeOffLeave result = apiInstance.timeOffLeaveUpdate(id, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeOffLeaveUpdate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  |
 **body** | [**TimeOffLeave**](TimeOffLeave.md)|  |

### Return type

[**TimeOffLeave**](TimeOffLeave.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="timeOffLeavetypeList"></a>
# **timeOffLeavetypeList**
> TimeOffLeaveTypeListContainer timeOffLeavetypeList()

List records



### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HrApi;


HrApi apiInstance = new HrApi();
try {
    TimeOffLeaveTypeListContainer result = apiInstance.timeOffLeavetypeList();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HrApi#timeOffLeavetypeList");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**TimeOffLeaveTypeListContainer**](TimeOffLeaveTypeListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

