/*
 * E2E.pt API
 * REST API para integração empresarial com os ERP <a href=\"http://www.primaverabss.com/\" target=\"_blank\">PRIMAVERA</a>, <a href=\"http://www.sage.pt/\" target=\"_blank\">SAGE</a>, <a href=\"https://www.phcsoftware.com/\" target=\"_blank\">PHC</a> e <a href=\"https://www.artsoft.pt/\" target=\"_blank\">ARTSOFT</a>.<br/><br/>Exemplos: <a href=\"https://e2e.pt/examples\" target=\"_blank\">https://e2e.pt/examples</a><br/><br/>Documentação: <a href=\"https://e2e.pt/documentation\" target=\"_blank\">https://e2e.pt/documentation</a><br/><br/>Mais informações, preços e demonstrações em: <a href=\"https://e2e.pt\" target=\"_blank\">https://e2e.pt</a>
 *
 * OpenAPI spec version: 2.24.3
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client;

import com.squareup.okhttp.*;
import okio.Buffer;
import okio.BufferedSink;
import okio.GzipSink;
import okio.Okio;

import java.io.IOException;

/**
 * Encodes request bodies using gzip.
 *
 * Taken from https://github.com/square/okhttp/issues/350
 */
class GzipRequestInterceptor implements Interceptor {
    @Override public Response intercept(Chain chain) throws IOException {
        Request originalRequest = chain.request();
        if (originalRequest.body() == null || originalRequest.header("Content-Encoding") != null) {
            return chain.proceed(originalRequest);
        }

        Request compressedRequest = originalRequest.newBuilder()
                                                   .header("Content-Encoding", "gzip")
                                                   .method(originalRequest.method(), forceContentLength(gzip(originalRequest.body())))
                                                   .build();
        return chain.proceed(compressedRequest);
    }

    private RequestBody forceContentLength(final RequestBody requestBody) throws IOException {
        final Buffer buffer = new Buffer();
        requestBody.writeTo(buffer);
        return new RequestBody() {
            @Override
            public MediaType contentType() {
                return requestBody.contentType();
            }

            @Override
            public long contentLength() {
                return buffer.size();
            }

            @Override
            public void writeTo(BufferedSink sink) throws IOException {
                sink.write(buffer.snapshot());
            }
        };
    }

    private RequestBody gzip(final RequestBody body) {
        return new RequestBody() {
            @Override public MediaType contentType() {
                return body.contentType();
            }

            @Override public long contentLength() {
                return -1; // We don't know the compressed length in advance!
            }

            @Override public void writeTo(BufferedSink sink) throws IOException {
                BufferedSink gzipSink = Okio.buffer(new GzipSink(sink));
                body.writeTo(gzipSink);
                gzipSink.close();
            }
        };
    }
}